# blah blah blah ...

import sys
sys.path.append('.')

import wcs_pv
from numpy import array

class WCS_PV():
    """
    Class to perform WCS computation from image or set of WCS parameters.
    """

#    def __init__(self, fich=None, crval1=0., crval2=0., crpix1=0., crpix2=0., cd=array[[1., 0.], [0., 1.]], dc=array[[1., 0.], [0., 1.]], pv=array[[0., 1., 0.], [0., 0., 1.]], nord=1):
    def __init__(self, fich=None, crval1=0., crval2=0., crpix1=0., crpix2=0., cd=None, dc=None, pv=None, nord=1):
        """
        Initialisation of the class, with filename of FITS image.
        """
        self.fich = fich
        if fich:
            crval1, crval2, crpix1, crpix2, cd, dc, pv, nord = wcs_pv.getwcs(fich)
        #else:
            #if not cd:
            #    cd = array[[1., 0.], [0., 1.]]
            #if not dc:
            #    dc = array[[1., 0.], [0., 1.]]
            #if not pv:
            #    pv = array[[0., 1., 0.], [0., 0., 1.]]
        self.crval1 = crval1
        self.crval2 = crval2
        self.crpix1 = crpix1
        self.crpix2 = crpix2
        self.cd = cd
        self.dc = dc
        self.pv = pv
        self.nord = nord

    def XY2SKY(self, x, y):
        """
        Method to convert (X, Y) coordinates to (RA, DEC).
        """
        return wcs_pv.xy2sky(self.crval1, self.crval2, self.crpix1, self.crpix2, self.cd, self.pv, self.nord, x, y)

    def SKY2XY(self, ra, dec):
        """
        Method to convert (RA, DEC) coordinates to (X, Y).
        """
        return wcs_pv.sky2xy(self.crval1, self.crval2, self.crpix1, self.crpix2, self.dc, self.pv, self.nord, ra, dec)
